/***************************************************************************
Name: CS Lite
Description: Control cookie permissions.
Author: wantora
Homepage: https://bitbucket.org/wantora/cslite-mod/

Copyright (C) 2007  Ron Beckman
Copyright (C) 2011  wantora

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");


const CSHIDDENMENUITEMS_CONTRACTID = '@wantora.bitbucket.org/cookiesafe-hiddenmenu-items;1';
const CSHIDDENMENUITEMS_CID = Components.ID('{a7cdbbe6-4e52-4675-884e-b85bb46dac17}');
const CSHIDDENMENUITEMS_IID = Components.interfaces.nsICookieSafeHiddenMenuItems;
const CSHIDDENMENUITEMS_SERVICENAME = 'CS Hidden Menu Items';

function nsCSHiddenMenuItems(){}
nsCSHiddenMenuItems.prototype = {
	classDescription: CSHIDDENMENUITEMS_SERVICENAME,
	classID: CSHIDDENMENUITEMS_CID,
	contractID: CSHIDDENMENUITEMS_CONTRACTID,

	testHiddenMenuItems: function(id) {
		var prefs = this.getPrefs();
		var ids = prefs.getCharPref('hiddenMenuItems');
		return (ids.indexOf(id)!=-1) ? true : false;
	},

	getHiddenMenuItems: function() {
		var prefs = this.getPrefs();
		var ids = prefs.getCharPref('hiddenMenuItems');
		return ids;
	},

	addHiddenMenuItems: function(id) {
		var found = this.testHiddenMenuItems(id);
		if (!found) {
			var prefs = this.getPrefs();
			var ids = prefs.getCharPref('hiddenMenuItems').split(' ');
			ids.push(id);

			//filter out all of the null values
			ids = ids.filter(function(value) { return value; });

			prefs.setCharPref('hiddenMenuItems',ids.join(' '));
		}
	},

	removeHiddenMenuItems: function(id) {
		var prefs = this.getPrefs();
		var ids = prefs.getCharPref('hiddenMenuItems').split(' ');
		ids = ids.filter(function(value) { return value != id; });
		prefs.setCharPref('hiddenMenuItems',ids.join(' '));
	},

	clearHiddenMenuItems: function() {
		var prefs = this.getPrefs();
		prefs.setCharPref('hiddenMenuItems','');
	},

	getPrefs: function() {
		return Components.classes["@mozilla.org/preferences-service;1"].
		getService(Components.interfaces.nsIPrefService).
		getBranch("extensions.cookiesafe.");
	},

	QueryInterface: XPCOMUtils.generateQI([CSHIDDENMENUITEMS_IID])
};

/**
* XPCOMUtils.generateNSGetFactory was introduced in Mozilla 2 (Firefox 4).
* XPCOMUtils.generateNSGetModule is for Mozilla 1.9.2 (Firefox 3.6).
*/
if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory([nsCSHiddenMenuItems]);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule([nsCSHiddenMenuItems]);
